﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using Infragistics;
using Infragistics.Controls.Charts;

namespace StackedSeriesInCodeXBAP
{
    /// <summary>
    /// Interaction logic for Page1.xaml
    /// </summary>
    public partial class Page1 : Page
    {
        GroupBy gb;
        public Page1()
        {
            InitializeComponent();

        }


        private void stack_SeriesCreated(object sender, Infragistics.Controls.Charts.StackedSeriesCreatedEventArgs e)
        {
            StackedFragmentSeries series = (StackedFragmentSeries)sender;

            if (series != null)
            {
                series.Title = series.ValueMemberPath.Replace("_Count", string.Empty);
            }
        }

        private void Page_Loaded(object sender, RoutedEventArgs e)
        {


            gb = new GroupBy();
            gb.GroupMemberPath = "Date";
            gb.KeyMemberPath = "Installation";
            gb.ValueMemberPath = "Emission";
            ObservableCollection<InstalationEmissionDateInformation> temp = TestEmissionsCollection.GetItemSource();
            gb.ItemsSource = temp;

            NumericYAxis yAxis = new NumericYAxis();
            CategoryXAxis xAxis = new CategoryXAxis();
            xAxis.ItemsSource = gb;
           // xAxis.Label = Resources["labels"] as DataTemplate;
            xAxis.Label = "{Key}";
            this.theChart.Axes.Add(xAxis);
            this.theChart.Axes.Add(yAxis);

            StackedColumnSeries series = new StackedColumnSeries();

            series.XAxis = xAxis;
            series.YAxis = yAxis;
            series.ItemsSource = gb;
            series.AutoGenerateSeries = true;
            theChart.Series.Add(series);

        }

        private void TextBlock_Loaded(object sender, RoutedEventArgs e)
        {

        }


    }


    public class TestEmissionsCollection
    {

        public static ObservableCollection<InstalationEmissionDateInformation> GetItemSource()
        {
            ObservableCollection<InstalationEmissionDateInformation> retVal = new ObservableCollection<InstalationEmissionDateInformation>();
            retVal.Add(new InstalationEmissionDateInformation("A", 5, "1/1/2012", 1));
            retVal.Add(new InstalationEmissionDateInformation("B", 2, "1/1/2012", 1));
            retVal.Add(new InstalationEmissionDateInformation("C", 7, "1/1/2012", 1));
            retVal.Add(new InstalationEmissionDateInformation("A", 6, "1/2/2012", 1));
            retVal.Add(new InstalationEmissionDateInformation("B", 3, "1/2/2012", 1));
            retVal.Add(new InstalationEmissionDateInformation("C", 8, "1/2/2012", 1));
            retVal.Add(new InstalationEmissionDateInformation("A", 6, "1/3/2012", 1));
            retVal.Add(new InstalationEmissionDateInformation("B", 3, "1/3/2012", 1));
            retVal.Add(new InstalationEmissionDateInformation("C", 6, "1/3/2012", 1));
            retVal.Add(new InstalationEmissionDateInformation("A", 4, "1/4/2012", 1));
            retVal.Add(new InstalationEmissionDateInformation("B", 3, "1/4/2012", 1));
            retVal.Add(new InstalationEmissionDateInformation("C", 7, "1/4/2012", 1));
            return retVal;
        }

        public TestEmissionsCollection()
        {

        }
    }

    public class InstalationEmissionDateInformation
    {
        public string Installation { get; set; }
        public Decimal Emission { get; set; }
        public string Date { get; set; }
        public Decimal Assignation { get; set; }

        public InstalationEmissionDateInformation(
            string installation,
            Decimal emission,
            string date,
            Decimal assignation)
        {
            Installation = installation;
            Emission = emission;
            Date = date;
            Assignation = assignation;
        }
    }

}
